



export class MasterDataWidget {
	
	tpl = `
		<div class="page-header">
			<h1>Stamgegevens</h1>
		</div>
		
		<span ez-if="toolboxConfig.desktopMode == false">
			<div class="col-12 col-sm-4 col-lg-3 setting-menu-tag-container">
				<h2>Instellingen</h2>
				<ul>
					<li><a href="/masterdata/appsettings/">App instellingen</a></li>
					
					<li><a href="/masterdata/users/">Gebruikersbeheer</a></li>
					
					<li><a href="/masterdata/groups/">Groepen</a></li>
				</ul>
			</div>
		</span>
	
		<div class="col-12 col-sm-4 col-lg-3 setting-menu-tag-container">
			<h2>Contracten</h2>
			<ul>
				<li><a href="/masterdata/contracts/types/">Contract typen</a></li>
			</ul>
		</div>

<!--
		<div class="col-12 col-sm-4 col-lg-3 setting-menu-tag-container">
			<h2>E-mail</h2>
			<ul>
				<li><a href="/masterdata/email/settings/">E-mail instellingen</a></li>
			</ul>
		</div>

		<div class="col-12 col-sm-4 col-lg-3 setting-menu-tag-container">
			<h2>Sales</h2>
			<ul>
				<li><a href="/masterdata/sales/settings/">Sales Instellingen</a></li>
				
				<li><a href="/masterdata/sales/article/">Artikelen</a></li>
				
				<li><a href="/masterdata/sales/articlegroup/">Artikelgroepen</a></li>
				
				<li><a href="/masterdata/sales/vat/">Btw tarieven</a></li>
				
				<li><a href="/masterdata/sales/slotplan/">Slot plannen</a></li>
				
				<li><a href="/masterdata/sales/pricetype/">Slot plannen pricetypes</a></li>
			</ul>
		</div>
		-->
		
		<div class="col-12 col-sm-4 col-lg-3 setting-menu-tag-container">
			<h2>Overig</h2>
			<ul>
				<li><a href="/masterdata/activity/">Logboek</a></li>
				
				<li><a href="/masterdata/license/">Registratie</a></li>
			</ul>
		</div>
	`;
	
	
	init(e) {
		if (toolboxConfig.admin == false) {
			gotoRoute( appUrl('/') );
			return;
		}
		
		let ezTpl = new EzTemplate( e );
		ezTpl.loadHtml( this.tpl );
		ezTpl.render();
	}
	
}

